SD_MACHINE_GET_CLASS(3)

NAME
sd_machine_get_class, sd_machine_get_ifindices - Determine the class and network interface indices of a locally running virtual machine or container

SYNOPSIS

#include <elogind/sd-login.h>

int sd_machine_get_class(const char* machine, char **class);

int sd_machine_get_ifindices(const char* machine, int **ifindices);

DESCRIPTION

sd_machine_get_class() may be used to determine the class of a locally running virtual machine or container that is registered with elogind-machined.service(8). The string returned is either "vm" or "container". The returned string needs to be freed with the libc free(3) call after use.

sd_machine_get_ifindices() may be used to determine the numeric indices of the network interfaces on the host that are pointing towards the specified locally running virtual machine or container that is registered with elogind-machined.service(8). The returned array needs to be freed with the libc free(3) call after use.

RETURN VALUE

On success, these calls return 0 or a positive integer. On failure, these calls return a negative errno-style error code.

  Errors

Returned errors may indicate the following problems:

-ENXIO
    The specified machine does not exist or is currently not running.

-EINVAL
    An input parameter was invalid (out of range, or NULL, where that is not accepted).

-ENOMEM
    Memory allocation failed.

NOTES

These APIs are implemented as a shared library, which can be compiled and linked to with the libelogind pkg-config(1) file.

SEE ALSO

elogind(8), sd-login(3), elogind-machined.service(8), sd_pid_get_machine_name(3)